function escapeHtml(str) {
  var div = document.createElement('div');
  $(div).text(str);
  return $(div).html();
}
function parseMsg() {
  var dateValue;
  var subject;
  var mailboxName = $('input[name="mailbox"]').val();
  var MSG = $('input[name="MSG"]').val();
  var myMailbox = encodeURIComponent(getParameterByName('myMailbox')) || '';
  var headers = new Array();
  $('.msgInit > .messageData > tbody > tr > td > .rfcheader .rfcheaderfields .rfcfieldvalue').each(function() {
    var val = $(this).html();
    if(isDate(val)) dateValue = val;
    else if($(this).prev().text().indexOf($('#subjectLabel').val()) >= 0) subject = val;
    else {
      var txt = $(this).prev().text() + ' ' + val;
      $('.msgHeaders').append('<p class="msgHeader">' + txt + '</p>');
    }
  });
  //var body = $('.letterText').html();
  //if(!body) body = $('.WordSection1').html();
  var body = $('.messageData > tbody > tr:last-child > td').html();
  $('.msgInit script, .msgInit style, .msgInit .rfcheaderlinks').remove();
  if(dateValue) {
    var ds = getDateStr(dateValue);
    $('.msgDate').text(ds);
  }
  $('.msgRawH a').attr('href', 'MIME/' + encodeURIComponent(mailboxName) + '/' + MSG + '-H.txt');
  $('.msgRawP a').attr('href', 'MIME/' + encodeURIComponent(mailboxName) + '/' + MSG + '-P.txt');
  if(subject) $('.msgSubject').prepend(subject);
  var sumSize = 0;
  var fileCount = 0;
  $('.msgInit a[href^="MIME/"]').each(function() {
    $(this).children('img,br,b').remove();
    var size = $(this).siblings('font').text();
    var sizeValue = size;
    //sizeValue = +sizeValue.replace(/^\((\d+)\s.*\)$/, "$1");
    sizeValue = +sizeValue.replace(/^\((\d+).*\)$/, "$1");
    if(/K|k|К|к/.test(size)) sizeValue *= 1024;
    else if(/M|m|М|м/.test(size)) sizeValue *= 1048576;
    sumSize += sizeValue;
    fileCount++;
    var fileName = $(this).text();
    fileName = fileName.replace(/^\s+/, '');
    size = size.replace(/bytes/, '');
    if(/^\(\d+\)$/.test(size)) size = '(' + $('#b').val().replace(/\^0/, sizeValue) + ')';
    $('.msgAttach').append(
      '<span><a href="' + $(this).attr('href') + '" target="_blank"><span>' + fileName + '</span></a> ' + size + '</span>'
    );
    $(this).parent().remove();
  });
  if(fileCount > 0 && $('#messageType').val() != 'contact') {
    var file = $('#fileTotals').val();
    var fcs = fileCount.toString();
    if(file == 'Файл') {
      if((fileCount > 1 && fileCount < 5) || (/[2-4]$/.test(fcs) && !/1[2-4]$/.test(fcs))) file += 'а';
      else if(/1$/.test(fileCount.toString()) && !/11$/.test(fileCount.toString())) file += '';
      else if(fileCount > 4) file += 'ов';
    }
    var fileTotals = fileCount.toString() + ' ' + file + ' (';
    var v;
    if(sumSize < 1024) {
      v = $('#b').val();
    } else if(sumSize < 1048576) {
      v = $('#K').val();
      sumSize = (sumSize/1024).toFixed(1);
    } else {
      v = $('#M').val();
      sumSize = (sumSize/1048576).toFixed(1);
    }
    if(v) {
      v = v.replace(/\^0/, sumSize.toString());
      fileTotals += v + ')';
      $('.msgAttachTotal').html('<span>' + fileTotals + '</span>');
    }
  }
  if($('.msgInit .nonmailObject').length) {
    // <task>
    var nmo = $('.msgInit .nonmailObject');
    if(!subject) {
      $('.msgSubject').prepend(nmo.find('.nonmailType').text().replace(/\s+$/, '') + ': ' + nmo.find('.nonmailTitle').html());
    } else {
      var txt = nmo.find('.nonmailType').text().replace(/\s+$/, '') + ': ' + nmo.find('.nonmailTitle').html();
      $('.msgHeaders').append('<p class="msgHeader">' + txt + '</p>');
    }
    nmo.children('tbody').children('tr:first-child').remove();
    body = nmo.find('.letterText').html() || '&nbsp;';
    nmo.find('.letterText').remove();
    var comment = nmo.find('.commentData').text();
    var commentLabel;
    if(comment.replace(/\s/g, '').length) {
      commentLabel = nmo.find('.commentData').siblings('th').text();
      nmo.find('.commentData').parent().remove();
    }
    $('.msgHeaders').append('<p class="msgHeader">' + nmo.parent().html() + '</p>');
    if(comment.replace(/\s/g, '').length) {
      $('.msgHeaders').append(
        '<p class="msgHeader"><table class="calendarpanel" cellspacing="2" cellpadding="4" width="100%"><tr><th align="left">' +
          commentLabel + '</th></tr><tr><td>' +
          '<textarea disabled="disabled" rows="2">' + comment + '</textarea></td></tr></table>' +
        '</p>'
      );
    }
    // </task>
  }
  if($('#messageType').length && $('#messageType').val() == 'contact') {
    // <contact>
    var contact = $('.msgInit .messageData'); 
    if($('.msgSubject div[data-value="EditContact"]').length) $('.msgSubject').prepend(contact.find('.name').text());
    else $('.msgHeaders').append('<p class="msgHeader">vCard: ' + contact.find('.name').text() + '</p>');
    if(contact.find('.date').length) $('.msgDate').text(contact.find('.date').text());
    $('.msgBody').append('<div class="backGrey"><table width="100%" cellpadding="3" cellspacing="0"></table></div>');
    var elemTable = $('.msgBody .backGrey table');
    contact.find('.element').each(function() {
      elemTable.append(
        '<tr><th align="right">' + $(this).children('.elemName').html() + ':</th>' +
        '<td align="left">' + $(this).children('.elemValue').html() + '</td></tr>'
      );
    });
    // </contact>
  }
  $('.msgBody').append(body);
  var msgBody = $('.msgBody');
  $('.msgInit .messageSubpart').each(function() {
    msgBody.append('<br /><br /><div class="greyBack"></div>');
    $(this).find('.rfcfieldvalue').each(function() {
      msgBody.find('.greyBack:last-child').append('<p class="msgHeader">' + $(this).prev().text() + ' ' + $(this).text() + '</p>');
    });
    var sb = $(this).find('.letterText').html();
    if(sb) msgBody.find('.greyBack:last-child').append('<div class="msgBody">' + sb + '</div>');
    if(!$(this).find('.letterText').length)
      $('.msgBody .greyBack:last-child').append(
        '<div class="msgBody">' + $(this).children('tbody').children('tr').eq(1).children('td').eq(0).html() + '</div></div>'
      );
  });
  if(!body && !$('.msgInit .messageSubpart').length)
    $('.msgBody').append($('.msgInit .messageData > tbody > tr').eq(1).children('td').eq(0).html());
  // <select>
  var selectArrowWidth = 46;
  $('select').each(function() {
    $(this).css('width', $(this).width() + selectArrowWidth);
    $(this).css('background-position', $(this).width() - 12 + 'px center');
  });
  // </select>
  $('.dialog .topPanelContainer img').on('click', function() {
    $('.dialog').hide();
    $('.overlay').hide();
  });
  $('.dialog .cancelButton').on('click', function() { $('.dialog .topPanelContainer img').trigger('click'); });
  $('.copymoveMsg .copyButton, .copymoveMsg .moveButton').on('click', function(e) {
    e.preventDefault();
    var sm = $('.copymoveMsg .folderTree .folderName.active').parent().attr('title');
    var action = $(this).hasClass('copyButton') ? 'Copy' : 'Move';
    if(sm) {
      if(action == 'Copy') {
        location.href = 'Hello.wssp?center=loadMessage&myMailbox=' + myMailbox + '&Mailbox=' +
          encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&Copy=&MailboxName=' + encodeURIComponent(sm);
      } else if(action == 'Move') {
        $.get(
          'Message.wssp',
          {
            Mailbox: mailboxName,
            MSG: MSG,
            Move: '',
            MailboxName: sm,
          },
          function(data) {
            var o = $.parseJSON(data);
            var errorCode = o.errorCode || '';
            location.href = 'Hello.wssp?center=loadMailbox&myMailbox=' + myMailbox + '&Mailbox=' +
              encodeURIComponent(mailboxName) + '&messageCode=' + encodeURIComponent(o.messageCode) + '&errorCode=' +
              encodeURIComponent(errorCode);
          }
        );
      }
    }
  });
  if($('.msgAttachAction').length) {
    $('input[name="StoreFiles"]').on('click', function() {
      $('.overlay').show();
      $('.store').show();
    });
    $('select[name="selectedWebFolder"] > option').each(function(i) {
      if(i == 0) {
        $('.store .folderTree').append(
          '<li class="folder" title="0"><div class="folderName">/</div><ul class="folderContent"></ul></li>'
        );
      } else if(i == 1) {
        $('.store .folderTree .folderContent').append(
          '<li class="folder" title="1"><div class="folderName">private</div><ul class="folderContent"></ul></li>'
        );
      } else {
        var ft = $(this).html().split('/');
        if(ft.length == 1) {
          $('.store .folderTree li[title="0"] > .folderContent').append(
            '<li class="folder" title="' + i + '"><div class="folderName">' + ft[0] + '</div>' +
            '<ul class="folderContent"></ul></li>'
          );
        } else {
          var fc = $('.store .folderTree .folderName:contains("/")').next();
          for(var j = 0; j < (ft.length - 1); j++) {
            fc = fc.find('.folderName:contains("' + ft[j] + '")').next();
          }
          if(fc.length == 1) {
            fc.append(
              '<li class="folder" title="' + i + '"><div class="folderName">' + ft[ft.length - 1] + '</div>' +
              '<ul class="folderContent"></ul></li>'
            );
          }
        }
      }
      $('.store .folderTree li[title="' + i + '"] > .folderName').on('click', function() {
        $('.folderTree .active').removeClass('active');
        $(this).addClass('active');
        if($(this).siblings('.folderContent').children('li').length) {
          $(this).siblings('.folderContent').slideToggle('fast');
        }
      });
    });
    var subscription = $('a[href$="attachment.dat"]');
    if(subscription.length) {
      $('#subscribeShared').show();
      $('#subscribeShared').on('click', function() {
        $.get(
          subscription.attr('href'),
          function(data) {
            var xmlText = new XMLSerializer().serializeToString(data);
            $.post(
              'importsubscription.wcgp',
              {
                Upload: xmlText,
                BtnSubmit: 'Upload',
              },
              function() {
                location.reload();
              }
            );
          }
        );
      });
    }
    $('.store .copyButton').on('click', function() {
      if($('.store .folderTree .folderName.active').length == 1) {
        var swf = $('.store .folderTree .folderName.active').parent().attr('title');
        location.href = 'Hello.wssp?center=loadMessage&myMailbox=' + myMailbox + '&Mailbox=' + 
          encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&StoreFiles=&selectedWebFolder=' + encodeURIComponent(swf);
      }
    });
    $('#TakeVCard').on('click', function() {
      location.href =
        'Hello.wssp?center=loadMessage&Mailbox=' + encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&TakeVCard=1';
    });
    $('#TakeCertificate').on('click', function() {
      location.href =
        'Hello.wssp?center=loadMessage&Mailbox=' + encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&TakeCertificate=1&selectedAddressBook=' + encodeURIComponent($('#selectedAddressBook').val());
    });
    $('#TakeAddress').on('click', function() {
      location.href =
        'Hello.wssp?center=loadMessage&Mailbox=' + encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&TakeAddress=1&selectedAddressBook=' + encodeURIComponent($('#selectedAddressBook').val());
    });
    $('#Decrypt').on('click', function() {
      location.href =
        'Hello.wssp?center=loadMessage&Mailbox=' + encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&Decrypt=1';
    });
    $('#Encrypt').on('click', function() {
      location.href =
        'Hello.wssp?center=loadMessage&Mailbox=' + encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&Encrypt=1';
    });
  }
  // <msgActions>
  $('.msgActions .toFolder').on('click', function() {
    showOverlayBlock('.copymoveMsg');
  });
  $('.msgActions .delete, .msgActions .undelete').on('click', function() {
    var action = $(this).hasClass('delete') ? 'Delete' : 'Undelete';
    location.href = 'Hello.wssp?center=loadMailbox&myMailbox=' + myMailbox + '&Mailbox=' +
      encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&' + encodeURIComponent(action) + '=&';
  });
  $('.msgActions .unread').on('click', function() {
    location.href = 'Hello.wssp?center=loadMailbox&myMailbox=' + myMailbox + '&Mailbox=' +
      encodeURIComponent(mailboxName) + '&MSG=' + MSG + '&Unread=&';
  });
  // </msgActions>
  /*
  if($('#messageType').val() != 'contact') {
    $('.msgInit img[src^="MIME/"]').each(function() {
      $('.msgBody').prepend(this.outerHTML);
    });
  }
  */
  $('.msgSubject a.flag').each(function() {
    $(this).attr('href', $(this).attr('href') + 'myMailbox=' + myMailbox);
  });
  $('.msgSubject div[data-value="EditTask"]').on('click', function() {
    location.href = 'Compose.wssp?OrigMessage=' +MSG+ '&OrigMailbox=' +encodeURIComponent(mailboxName)+ '&Operation=EditTask';
  });
  $('.msgSubject div[data-value="EditNote"]').on('click', function() {
    location.href = 'Compose.wssp?OrigMessage=' +MSG+ '&OrigMailbox=' +encodeURIComponent(mailboxName)+ '&Operation=EditNote';
  });
  $('.msgSubject div[data-value="EditEvent"]').on('click', function() {
    location.href = 'Compose.wssp?OrigMessage=' +MSG+ '&OrigMailbox=' +encodeURIComponent(mailboxName)+ '&Operation=EditEvent';
  });
  $('.msgSubject div[data-value="EditContact"]').on('click', function() {
    location.href = 'Contact.wssp?OrigMessage=' + MSG + '&OrigMailbox=' + encodeURIComponent(mailboxName);
  });
  $('.msgSubject div[data-value="SendMDN"]').on('click', function() {
    location.href = 'Hello.wssp?center=loadMessage&MSG=' + MSG + '&Mailbox=' + encodeURIComponent(mailboxName) + '&SendMDN=1';
  });
  $('#arrLeftPage').on('click', function() {
    var newMsg = $('#nextMsg').val() || MSG;
    location.href = 'Hello.wssp?center=loadMessage&Mailbox=' + encodeURIComponent(mailboxName) + '&MSG=' + newMsg;
  });
  $('#arrRightPage').on('click', function() {
    var newMsg = $('#prevMsg').val() || MSG;
    location.href = 'Hello.wssp?center=loadMessage&Mailbox=' + encodeURIComponent(mailboxName) + '&MSG=' + newMsg;
  });
  $('.calendarpanel .button').on('click', function() {
    var params = {};
    params['Mailbox'] = mailboxName;
    params['MSG'] = MSG;
    params[$(this).attr('data-value')] = 1;
    params[$('.calendarpanel textarea').attr('name')] = $('.calendarpanel textarea').val();
    params[$('.calendarpanel select').attr('name')] = $('.calendarpanel select').val();
    var center = 'loadMailbox';
    if($('input[name="isEvent"]').val() == 1) center = 'loadCalendar';
    $.post(
      'Message.wssp',
      params,
      function(data) {
        var o = $.parseJSON(data);
        if(o.errorCode) alert(o.messageCode);
        else location.href = 'Hello.wssp?center=' + center + '&Mailbox=' + encodeURIComponent(urlParams.Mailbox);
      }
    );
  });
  // <hide buttons in tasks>
  if($('.attendee').length) {
      var myaddr = $('#myaddr').val().replace(/([@.])/g, '\\$1');
      var datavalue = '';
      if($('#' + myaddr).val() == 'ACCEPTED' || $('#' + myaddr).val() == 'IN-PROCESS') {
        datavalue = 'Accepted';
      } else if($('#' + myaddr).val() == 'TENTATIVE') {
        datavalue = 'Tentative';
      }
      $('div[data-value="' + datavalue + '"]').css('visibility', 'hidden');
  }
  // </hide buttons in tasks>
};

function getDateStr(initDate) {
  var d = new Date(initDate);
  var dc = {
    dd: d.getDate(),
    mm: d.getMonth() + 1,
    yyyy: d.getFullYear(),
    hh: d.getHours(),
    min: d.getMinutes(),
    ss: d.getSeconds(),
  };
  if(dc.dd < 10) dc.dd = '0' + dc.dd;
  if(dc.mm < 10) dc.mm = '0' + dc.mm;
  if(dc.hh < 10) dc.hh = '0' + dc.hh;
  if(dc.min < 10) dc.min = '0' + dc.min;
  if(dc.ss < 10) dc.ss = '0' + dc.ss;
  var result = dc.dd + '-' + dc.mm + '-' + dc.yyyy + ' ' + dc.hh + ':' + dc.min + ':' + dc.ss;
  return result;
}
function isDate(val) {
  var d = new Date(val);
  return !isNaN(d.valueOf());
}

