$(window).on('load', function() {
  var headArrowWidth = 26;
  var selectArrowWidth = 46;
  $('.settingsGroup .head a').each(function() {
    $(this).css('width', $(this).children('span').width() + headArrowWidth);
    $(this).css('background-position', $(this).children('span').width() + 4 + 'px 0px');
  });
  $('.mainPanelContainer select').each(function() {
    $(this).css('width', $(this).width() + selectArrowWidth);
    $(this).css('background-position', $(this).width() - 12 + 'px center');
  });
  $('.updateButton a[href="#"]').on('click', function() {
    $(this).parent().siblings('.updateButton').children('input').val('');
    $('body>form')[0].submit();
  });
  $('.restoreButton a[href="#"]').on('click', function(e) {
    e.preventDefault();
    $('body>form')[0].reset();
  });
  $('.settingsRestoreDefault a').on('click', function(e) {
    e.preventDefault();
    $('body>form')[0].reset();
  });
  $('.settingsGroup .head a').on('click', function(e) {
    e.preventDefault();
    $('.copyright').hide();
    $(this).toggleClass('active');
    $(this).parent().siblings('.body').slideToggle('fast', function() {
      $('form').css('min-height', $('.navigation').height() + $('#container').height());
      $('.copyright').show();
    });
  });
  $('.settingsGroup .head a').trigger('click');
  $(window).trigger('resize');
  setTimeout(function() { $('.mainPanelContainer').css('visibility', 'visible'); }, 500);
});

$(window).on('resize', function() {
  $('form').css('min-height', $('.navigation').height() + $('#container').height());
  var lpc_width = $('.leftPanelContainer').width();
  if(!lpc_width) lpc_width = 20;
  else lpc_width += 60;
  $('.mainPanelContainer > table').css(
    'width',
    $('.navigation').width() - lpc_width
  );
  $('.mainPanelContainer .scrollTable').css(
    'width',
    $('.navigation').width() - lpc_width
  );
  $('.mainPanelContainer .scrollTable').css(
    'height',
    $('body').height() - $('.navigation').height() - 230
  );
  if($('.scrollTable').length && $('.buttonContainer').length) {
    var bc = $('.buttonContainer');
    bc.css({
      position: 'absolute',
      bottom: '0px',
    }); 
  }
});

