var Mailbox = (function ($, messages, variables, strings, sortMailbox) { 
    var myMailbox = {};
	
	function mailboxController () {
		
		function resetButtonRename() {
			alert('resetButtonRename');
			$("body > #popupRename").remove();
			$("body > #overlay").remove();
			$('#buttonBuildMailbox').trigger('click');
		}
		
		function submitButtonRename() {
			alert('submitButtonRename');
			$("body > #popupRename").remove();
			$("body > #overlay").remove();
			$('#buttonBuildMailbox').trigger('click');
		}
		
		this.clickButton = function () {
			console.log('myController.clickButton() START');
			//$('#buttonReset').on('click',
			$('body').on('click', '#buttonReset', function(){
			  console.log('Вы нажали на элемент "buttonReset"');
				resetButtonRename(); 
			});
			$('body').on('click', '#buttonRename', function(){
			  console.log('Вы нажали на элемент "buttonRename"');
				submitButtonRename(); 
			});
		}
		
		function createRename(){
			$("body > #popupRename").remove();
			var popupRename = '';
			popupRename += '<div id="popupRename">';
			popupRename += '<p align="center"><input type="button" name="Reset" id="buttonReset" value="' + strings.ResetButton + '" />';
			popupRename += '&nbsp;';
			popupRename += '<input type="button" name="Rename" id="buttonRename" value="' + strings.RenameMailboxButton + '" /></p>';
			popupRename += '</div>';
			
			var docWidth = (parseInt($(document).width())/2 - 150) + 'px';
			var docHeight = (parseInt($(document).height())/2 - 75) + 'px';
			
			$(popupRename)
				.appendTo("body")
				.css({
				'opacity': 1.0,
				'position': 'absolute',
				'top': docHeight,
				'left': docWidth,
				'width': '300px',
				'height': '150px',
				'background-color': 'white',
				'z-index': 5100
			});
				
			popupRename = '';
		}		
		
		this.mouseOverOut = function () {
			$('#table-messages > tbody > tr').hover(
				function () {
								if ($(this).hasClass('activMessage')) return;
								$(this).removeClass('outMessage').addClass('overMessage');
							},
				function () {
								if ($(this).hasClass('activMessage')) return;
								$(this).removeClass('overMessage').addClass('outMessage');
							}
			)
		}
		
		function statusButtons () {
			var flagChecked = false;
			$('input:checkbox').each(function() { if ($(this).prop('checked')) flagChecked = true; }
			);
			if (flagChecked) {
				$('#buttonMailbox-copy').removeClass('movedfolder-inact inactiv').addClass('movedfolder-act activ pointer');
				$('#buttonMailbox-forward').removeClass('forward-inact inactiv').addClass('forward-act activ pointer');
				$('#buttonMailbox-redirect').removeClass('redirect-inact inactiv').addClass('redirect-act activ pointer');
				$('#buttonMailbox-delete').removeClass('delete-inact inactiv').addClass('delete-act activ pointer');
				$('#buttonMailbox-putflag').removeClass('putflag-inact inactiv').addClass('putflag-act activ pointer');
				$('#buttonMailbox-checkmark').removeClass('checkmark-inact inactiv').addClass('checkmark-act activ pointer');
				$('#buttonMailbox-print').removeClass('print-inact inactiv').addClass('print-act activ pointer');
				$('#buttonMailbox-yet').removeClass('yet-inact inactiv').addClass('yet-act activ pointer');
			} else {
				$('#buttonMailbox-copy').removeClass('movedfolder-act activ pointer').addClass('movedfolder-inact inactiv');
				$('#buttonMailbox-forward').removeClass('forward-act activ pointer').addClass('forward-inact inactiv');
				$('#buttonMailbox-redirect').removeClass('redirect-act activ pointer').addClass('redirect-inact inactiv');
				$('#buttonMailbox-delete').removeClass('delete-act activ pointer').addClass('delete-inact inactiv');
				$('#buttonMailbox-putflag').removeClass('putflag-act activ pointer').addClass('putflag-inact inactiv');
				$('#buttonMailbox-checkmark').removeClass('checkmark-act activ pointer').addClass('checkmark-inact inactiv');
				$('#buttonMailbox-print').removeClass('print-act activ pointer').addClass('print-inact inactiv');
				$('#buttonMailbox-yet').removeClass('yet-act activ pointer').addClass('yet-inact inactiv');
			}
			if (flagChecked) {
				$('.headerMailbox > div').hover(
					function () { jQuery(this).addClass('buttonHover'); },
					function () { jQuery(this).removeClass('buttonHover'); }
				)
			} else {
				$('.headerMailbox > div').hover(function () { jQuery(this).removeClass('buttonHover'); } )
			}
		}
		
		this.changeCheck = function () {
			$('.checkMessage').change(function(){ 
				var thisID = '';
				if($(this).prop("checked")){ 
					thisID = $(this).attr("id");
					$('#message-' + thisID).removeClass('overMessage').removeClass('outMessage').addClass('activMessage');
					statusButtons ();
				} else { 
					thisID = $(this).attr("id");
					$('#message-' + thisID).removeClass('activMessage').addClass('overMessage');
					statusButtons ();
				} 
			});
		}

		this.openYet = function () {
			$('#buttonMailbox-yet').click(function(){ 
				if($(this).hasClass('activ') && $('#openYet').css('display') == 'none') $('#openYet').show(); else $('#openYet').hide(); 
				$('#openYet > div#spamYet').hover(
					function () { $(this).removeClass('itemOut icon30x20-spam-gray').addClass('itemOver icon30x20-spam-white'); },
					function () { $(this).removeClass('itemOver icon30x20-spam-white').addClass('itemOut icon30x20-spam-gray'); }
				)
				$('#openYet > div#flagYet').hover(
					function () { $(this).removeClass('itemOut icon30x20-flag-gray').addClass('itemOver icon30x20-flag-white'); },
					function () { $(this).removeClass('itemOver icon30x20-flag-white').addClass('itemOut icon30x20-flag-gray'); }
				)
			});
			$(document).mouseup(function (e) {
				if ($("#openYet").has(e.target).length === 0) $("#openYet").hide();
			});
		}

		this.openCopy = function () {
			$('#buttonMailbox-copy').click(function(){ 
				if($(this).hasClass('activ') && $('#openCopy').css('display') == 'none') $('#openCopy').show(); else $('#openCopy').hide(); 
				$('#openCopy > div#spamCopy').hover(
					function () { $(this).removeClass('itemOut icon30x20-spam-gray').addClass('itemOver icon30x20-spam-white'); },
					function () { $(this).removeClass('itemOver icon30x20-spam-white').addClass('itemOut icon30x20-spam-gray'); }
				)
				$('#openCopy > div#flagCopy').hover(
					function () { $(this).removeClass('itemOut icon30x20-flag-gray').addClass('itemOver icon30x20-flag-white'); },
					function () { $(this).removeClass('itemOver icon30x20-flag-white').addClass('itemOut icon30x20-flag-gray'); }
				)
			});
			$(document).mouseup(function (e) {
				if ($("#openCopy").has(e.target).length === 0) $("#openCopy").hide();
			});
		}

		this.createSelectCopy = function (arrMailboxes) {
			for (var i = 0; i < 7; i++) {
				for (var j = 0; j < arrMailboxes[i].length; j++) {
					$("#selectCopy").append( $('<option value="' + i + j + '">' + arrMailboxes[i][j].htmlName + '</option>'));
				}
			}
		}

		this.openBuildMailbox = function () {
			var flagClick = false;
			
		
			$('#buttonBuildMailbox').click(function(){ 
				console.log('0: myController.flagClick = ' + flagClick);
				if (!flagClick) {
					console.log('0-0 !flagClick');
					$(this).removeClass('buildMailboxGrey').addClass('buildMailboxGreen');
					$('#openBuildMailbox').slideToggle("slow");
					flagClick = true;
				} else {
					console.log('0-1 flagClick');
					$('#openBuildMailbox').slideUp("slow");
					$(this).removeClass('buildMailboxGreen').addClass('buildMailboxGrey');
					flagClick = false;
				}
				/*
				$('#openBuildMailbox > div#buildMailbox-0').hover(
					function () { $(this).removeClass('itemOut').addClass('itemOver'); },
					function () { $(this).removeClass('itemOver').addClass('itemOut'); }
				)
				*/
				$('#openBuildMailbox > div.itemMiddle').hover(
					function () { $(this).removeClass('itemOut').addClass('itemOver'); },
					function () { $(this).removeClass('itemOver').addClass('itemOut'); }
				)
				$('#openBuildMailbox > div#buildMailbox-4').hover(
					function () { $(this).removeClass('itemOut').addClass('itemOver'); },
					function () { $(this).removeClass('itemOver').addClass('itemOut'); }
				)
				
				$('#buildMailbox-2').click(function(){ 
					Overlay.createOverley(true);
					createRename();
				});
			});
		}

		this.clickSubBuildMailbox = function () {
			$('#buildMailbox-0').click(function(){ 
				if($('#subBuildMailbox_0').css('display') == 'none') {
					$('#subBuildMailbox_0').show();
				} else {
					$('#subBuildMailbox_0').hide(); 
				}
				flagClick = false;
			});
		}

		function reloadSortMailbox (sortMailbox,mailboxjavaName,mailboxName,totalMessages,arrMailboxes,id) {
			var index = 0;
			console.log('id = ' + id);
			for (var i = 0; i < sortMailbox.length; i++) {
				console.log('i = ' + i + ', sortMailbox[i][1] = ' + sortMailbox[i][1]);
				var str = 'sortID_' + sortMailbox[i][1];
				if (str == id) { index = i; break; }
			}
			console.log('mailbox.wssp?Mailbox=' + mailboxjavaName + '&Sort=' + sortMailbox[index][1] + '&SDir=' + sortMailbox[index][2] + '&Limit=' + sortMailbox[index][3]);
			//return;
			SendFormData.sortMailboxMethod('mailbox.wssp?Mailbox=' + mailboxjavaName + '&Sort=' + sortMailbox[index][1] + '&SDir=' + sortMailbox[index][2] + '&Limit=' + sortMailbox[index][3],mailboxjavaName,mailboxName,totalMessages,arrMailboxes);
		}
		
		this.sendFormMessage = function (mailboxjavaName,mailboxName,totalMessages,arrMailboxes) {
			var fieldsForm = {
				charset: strings.Charset,
				mailbox:mailboxjavaName,
				limit: 20,
				filter: "",
				Search: "",
				mailboxName:mailboxName,
				redirectAddresses: ""
			}
			var buttonClick = "";
			var copyToMailbox = '';
			$('#selectCopy').click(function(){
				var strMSG = '';
				var arrChecked = $('#table-messages input:checkbox:checked');
				arrChecked.each(function(index, el){
					strMSG += 'Msg=' + el.value + '&';
				});
				buttonClick = 'Copy=copy&';
				var selectMailbox = $(this).val();
				var index0 = selectMailbox[0];
				var index1 = selectMailbox[1];
				copyToMailbox = arrMailboxes[index0][index1].javaName;
				var strData = 	'FormCharset=' + fieldsForm.charset + '&' +
								'mailbox=' + fieldsForm.mailbox + '&' +
								'Limit=' + fieldsForm.limit + '&' +
								'Search=' + fieldsForm.Search + '&' +
								'mailboxName=' + copyToMailbox + '&' +
								strMSG +
								buttonClick +
								'RedirectAddresses=' + fieldsForm.redirectAddresses;
				console.log('strData = ' + strData);
				SendFormData.copyMessage(strData,mailboxjavaName,mailboxName,totalMessages,arrMailboxes);
			});
			$('#buttonMailbox-redirect').click(function(){
				var strMSG = '';
				var arrChecked = $('#table-messages input:checkbox:checked');
				arrChecked.each(function(index, el){
					strMSG += 'Msg=' + el.value + '&';
				});
				buttonClick = 'Redirect=redirect&';
				var strData = 	'FormCharset=' + fieldsForm.charset + '&' +
								'mailbox=' + fieldsForm.mailbox + '&' +
								'Limit=' + fieldsForm.limit + '&' +
								'Search=' + fieldsForm.Search + '&' +
								strMSG +
								buttonClick;
								//'RedirectAddresses=' + fieldsForm.redirectAddresses;
				console.log('strData = ' + strData);
				SendFormData.redirectMessage(strData,mailboxjavaName,mailboxName,totalMessages,arrMailboxes);
			});
			$('#buttonMailbox-delete').click(function(){
				var strMSG = '';
				var arrChecked = $('#table-messages input:checkbox:checked');
				arrChecked.each(function(index, el){
					strMSG += 'Msg=' + el.value + '&';
				});
				buttonClick = 'Delete=delete&';
				var strData = 	'FormCharset=' + fieldsForm.charset + '&' +
								'mailbox=' + fieldsForm.mailbox + '&' +
								'Limit=' + fieldsForm.limit + '&' +
								'Search=' + fieldsForm.Search + '&' +
								strMSG +
								buttonClick +
								'RedirectAddresses=' + fieldsForm.redirectAddresses;
				console.log('strData = ' + strData);
				SendFormData.deleteMessage(strData,mailboxjavaName,mailboxName,totalMessages,arrMailboxes);
			});
			$('#buttonMailbox-checkmark').click(function(){
				var strMSG = '';
				var arrChecked = $('#table-messages input:checkbox:checked');
				arrChecked.each(function(index, el){
					strMSG += 'Msg=' + el.value + '&';
				});
				buttonClick = 'Read=read&';
				var strData = 	'FormCharset=' + fieldsForm.charset + '&' +
								'mailbox=' + fieldsForm.mailbox + '&' +
								'Limit=' + fieldsForm.limit + '&' +
								'Search=' + fieldsForm.Search + '&' +
								strMSG +
								buttonClick +
								'RedirectAddresses=' + fieldsForm.redirectAddresses;
				console.log('strData = ' + strData);
				SendFormData.readMessage(strData,mailboxjavaName,mailboxName,totalMessages,arrMailboxes);
			});
		}
		
		this.sortMailbox = function (sortMailbox,mailboxjavaName,mailboxName,totalMessages,arrMailboxes) {
			$('.itemSubBuildMailbox').click(function(){
				id_click = $(this).attr("id");
				reloadSortMailbox (sortMailbox,mailboxjavaName,mailboxName,totalMessages,arrMailboxes,id_click);
			});
		}

		this.startBuildMailbox = function (sortMailbox) {
			for (var i = 0; i < sortMailbox.length; i++) {
				console.log('i = ' + i + ', sortMailbox[i][0] = ' + sortMailbox[i][0]);
				var str = sortMailbox[i][0];
				if (str) { 
					$('#sortID_' + sortMailbox[i][1]).css('color', '#33CC99');
					str = sortMailbox[i][2];
					console.log('sortMailbox[i][2] = ' + str);
					if (parseInt(str)) $('#sortID_' + sortMailbox[i][1]).removeClass('arrGreenBottom10x11').addClass('arrGreenTop10x11');
					else $('#sortID_' + sortMailbox[i][1]).removeClass('arrGreenTop10x11').addClass('arrGreenBottom10x11');
					break; 
				}
			}
		}

	} // /mailboxController

						 
    myMailbox.startMethod = function (mailboxjavaName,mailboxName,totalMessages,arrMailboxes) { 
		//console.log('mailboxjavaName = ' + mailboxjavaName + ', mailboxName = ' + mailboxName + ', totalMessages = ' + totalMessages + ', arrMailboxesAdd = ' + arrMailboxesAdd);
		for (var i = 0; i < totalMessages; i++) {
			if (messages[i][0] == 'Unread') $('#message-' + messages[i][2]).addClass('bold');
		}
		
		$('#openYet, #openCopy, #openBuildMailbox').hide();
		$('#titleMailbox').html(mailboxName);


		var myController = new mailboxController();
		
		myController.mouseOverOut();
		myController.changeCheck();
		myController.openYet();
		myController.createSelectCopy(arrMailboxes);
		myController.openCopy();
		myController.startBuildMailbox(sortMailbox);
		myController.openBuildMailbox();
		//myController.clickSubBuildMailbox();
		
		myController.sendFormMessage (mailboxjavaName,mailboxName,totalMessages,arrMailboxes);
		myController.sortMailbox (sortMailbox,mailboxjavaName,mailboxName,totalMessages,arrMailboxes);

		myController.clickButton();
	}

    return myMailbox; 
}(jQuery, messages, variables, strings, sortMailbox));
